from matrica import *
from Stack import *

##Funkcija za zadanu poziciju na ploči dimenzija n x n
##vraća sve pozicije na koje skakač može doći s polja p
def susjed(p, n):
    x, y = p[0], p[1]
    d = [[-2, -1], [-1, -2], [1, -2], [2, -1], [-2, 1], [-1, 2], [1, 2], 
        [2, 1]]
    for t in d:
        if 0 <= x + t[0] < n and 0 <= y + t[1] < n:
            yield (x + t[0], y + t[1])

def main():
    n = int(input('Unesi dimenziju šahovske ploče '))
    p = input('Unesi početnu poziciju skakača (u obliku slovo broj npr. A3) ')
    a = Matrica(n, n)
    x, y = int(p[1]) - 1, ord(p[0]) - 65
    s = Stack()
    s.push((x, y))
    rb = 1
    last = None
    ##Dok nismo popunili sva polja na kvadratnoj ploči dimenzije n * n ili
    ##dok ima mogućih pomaka
    while rb <= n ** 2 and not s.isEmpty():
        ##Uzimamo gornji element sa stoga
        t = s.pop()
        ##Ukoliko se radi o još ne posjećenom polju
        if (a[t] == 0):
            ##Vraćamo polje na stog
            s.push(t)
            ##Na odgovarajuće mjesto u matrici pišemo redni broj skoka
            a[t] = rb
            rb += 1
            ##Sva polja do kojih možemo doći iz trenutnog polja
            ##stavljamo na vrh stoga
            for k in susjed(t, n):
                if a[k] == 0 and k != last:
                    s.push(k)
            last = None
        ##Ukoliko smo sa stoga učitali polje na kojem smo već bili
        else:
            ##Pamtimo poziciju polja kako se ne bismo ponovo u njega 
            ## vratili i time načinili beskonačnu petlju
            last = t
            ##Uzimamo redni broj polja
            rb = a[t]
            ##Polje označavamo kao još neposjećeno
            a[t] = 0

    ##Ako stog nije prazan znači da smo popunili cijelu šahovsku
    ##ploču te je to ujedno i rješenje
    if not s.isEmpty():
        print(a)
    else:
        print('Ne postoji')
    return

main()
